import woob.capabilities.bill as OLD
from woob.capabilities.base import Enum

# can't import *, __all__ is incomplete...
for attr in dir(OLD):
    globals()[attr] = getattr(OLD, attr)

try:
    __all__ = OLD.__all__
except AttributeError:
    pass


from .base import find_object


class DocumentCategory(Enum):
    """
    used for categories attribute in module.py
    use OTHER category sparingly,
    prefer define a new value if you really need a new one
    respect uppercase for enum and titled for string

    tag Module with it:
    example:
        document_categories = {DocumentCategory.ENERGY}
    """

    ADMINISTRATIVE = u'Administrative'
    BANK_INSURANCE = u'Bank & Insurance'
    BILLING = u'Billing'
    BUSINESS = u'Business'
    ENERGY = u'Energy Provider'
    FOOD = u'Food'
    INTERNET_TELEPHONY = u'Internet & Telephony'
    LEISURE = u'Leisure'
    OTHER = u'Other'
    REAL_ESTATE = u'Real estate'
    SAFE_DEPOSIT_BOX = u'Safe deposit box'
    SHOPPING = u'Shopping'
    SOFTWARE = u'Software'
    TAX = u'Tax'
    TOURISM = u'Tourism'
    TRANSPORT = u'Transport'
    WATER = u'Water Provider'


Subscription._fields['is_fake'] = BoolField("Set True if website doesn't provide a real subscription", default=False)


class CapDocument(OLD.CapDocument):
    def get_subscription(self, _id):
        return find_object(
            self.iter_subscription(),
            id=_id,
            error=SubscriptionNotFound,
        )


del OLD
